#
# Copyright (c) 2013-2023 NIBIO.
#
# This file is part of VIPSWeb 
# (see https://gitlab.nibio.no/VIPS/VIPSWeb).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
#

#from django.shortcuts import render
from django.http import JsonResponse, HttpResponseRedirect
from django.shortcuts import render
from django.conf import settings
from security.models import VipsLogicUser
import requests

# Create your views here.
# VIPSLogic login handling
# Direct login with a user UUID
# Deprecated. See check_login_middleware for handling
def login_user_uuid(request, user_uuid):
    found_user = VipsLogicUser.find_by_uuid(user_uuid)
    if found_user != None:
        request.session["vips_logic_user"] = found_user
        request.session["user_uuid"] = user_uuid
        request.session.set_expiry(2592000) # 30 days lasting
        return JsonResponse({"success":"true"})
    else:
        return JsonResponse({"success":"false"})

# Deprecated
def login_form(request):
    return render(request, "security/login_form.html")

def logout(request):
    response = HttpResponseRedirect("/")
    if request.session["vips_logic_user"] != None:
        user_uuid = request.session["vips_logic_user"]["userUuid"]
        # Delete session info
        request.session["vips_logic_user"] = None
        # Delete user UUID
        requests.delete("%s://%s/rest/user/uuid/%s" % (settings.VIPSLOGIC_PROTOCOL, settings.VIPSLOGIC_SERVER_NAME,user_uuid))

    # Return to index page
    return response